diff -ruN vdr-1.7.11/recorder.c vdr-1.7.12/recorder.c
--- vdr-1.7.11/recorder.c	2009-12-06 12:34:41.000000000 +0100
+++ vdr-1.7.12/recorder.c	2010-01-29 17:37:22.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recorder.c 2.7 2009/12/06 11:34:41 kls Exp $
+ * $Id: recorder.c 2.8 2010/01/29 16:37:22 kls Exp $
  */
 
 #include "recorder.h"
@@ -21,8 +21,8 @@
 
 // --- cRecorder -------------------------------------------------------------
 
-cRecorder::cRecorder(const char *FileName, tChannelID ChannelID, int Priority, int VPid, const int *APids, const int *DPids, const int *SPids)
-:cReceiver(ChannelID, Priority, VPid, APids, Setup.UseDolbyDigital ? DPids : NULL, SPids)
+cRecorder::cRecorder(const char *FileName, const cChannel *Channel, int Priority)
+:cReceiver(Channel, Priority)
 ,cThread("recording")
 ,recordingInfo(FileName)
 {
@@ -32,15 +32,15 @@
 
   ringBuffer = new cRingBufferLinear(RECORDERBUFSIZE, MIN_TS_PACKETS_FOR_FRAME_DETECTOR * TS_SIZE, true, "Recorder");
   ringBuffer->SetTimeouts(0, 100);
-  cChannel *Channel = Channels.GetByChannelID(ChannelID);
-  int Pid = VPid;
-  int Type = Channel ? Channel->Vtype() : 0;
-  if (!Pid && APids) {
-     Pid = APids[0];
+
+  int Pid = Channel->Vpid();
+  int Type = Channel->Vtype();
+  if (!Pid && Channel->Apid(0)) {
+     Pid = Channel->Apid(0);
      Type = 0x04;
      }
-  if (!Pid && DPids) {
-     Pid = DPids[0];
+  if (!Pid && Channel->Dpid(0)) {
+     Pid = Channel->Dpid(0);
      Type = 0x06;
      }
   frameDetector = new cFrameDetector(Pid, Type);
diff -ruN vdr-1.7.11/recorder.h vdr-1.7.12/recorder.h
--- vdr-1.7.11/recorder.h	2009-01-06 11:44:58.000000000 +0100
+++ vdr-1.7.12/recorder.h	2010-01-29 17:32:32.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recorder.h 2.1 2009/01/06 10:44:58 kls Exp $
+ * $Id: recorder.h 2.2 2010/01/29 16:32:32 kls Exp $
  */
 
 #ifndef __RECORDER_H
@@ -34,9 +34,9 @@
   virtual void Receive(uchar *Data, int Length);
   virtual void Action(void);
 public:
-  cRecorder(const char *FileName, tChannelID ChannelID, int Priority, int VPid, const int *APids, const int *DPids, const int *SPids);
-               // Creates a new recorder for the channel with the given ChannelID and
-               // the given Priority that will record the given PIDs into the file FileName.
+  cRecorder(const char *FileName, const cChannel *Channel, int Priority);
+               // Creates a new recorder for the given Channel and
+               // the given Priority that will record into the file FileName.
   virtual ~cRecorder();
   };
 
diff -ruN vdr-1.7.11/recording.c vdr-1.7.12/recording.c
--- vdr-1.7.11/recording.c	2010-01-02 14:46:05.000000000 +0100
+++ vdr-1.7.12/recording.c	2010-01-16 12:18:30.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 2.21 2010/01/02 13:46:05 kls Exp $
+ * $Id: recording.c 2.22 2010/01/16 11:18:30 kls Exp $
  */
 
 #include "recording.h"
@@ -524,8 +524,8 @@
 
 struct tCharExchange { char a; char b; };
 tCharExchange CharExchange[] = {
-  { '~',  '/'    },
-  { '/',  '~'    },
+  { FOLDERDELIMCHAR,  '/' },
+  { '/',  FOLDERDELIMCHAR },
   { ' ',  '_'    },
   // backwards compatibility:
   { '\'', '\''   },
@@ -546,10 +546,10 @@
               switch (*p) {
                      // characters that can be mapped to other characters:
                      case ' ': *p = '_'; break;
-                     case '~': *p = '/'; break;
+                     case FOLDERDELIMCHAR: *p = '/'; break;
                      // characters that have to be encoded:
                      default:
-                       if (strchr(InvalidChars, *p) || *p == '.' && (!*(p + 1) || *(p + 1) == '~')) { // Windows can't handle '.' at the end of file/directory names
+                       if (strchr(InvalidChars, *p) || *p == '.' && (!*(p + 1) || *(p + 1) == FOLDERDELIMCHAR)) { // Windows can't handle '.' at the end of file/directory names
                           int l = p - s;
                           s = (char *)realloc(s, strlen(s) + 10);
                           p = s + l;
@@ -565,7 +565,7 @@
               switch (*p) {
                 // mapped characters:
                 case '_': *p = ' '; break;
-                case '/': *p = '~'; break;
+                case '/': *p = FOLDERDELIMCHAR; break;
                 // encoded characters:
                 case '#': {
                      if (strlen(p) > 2 && isxdigit(*(p + 1)) && isxdigit(*(p + 2))) {
@@ -635,7 +635,7 @@
      // avoid blanks at the end:
      int l = strlen(name);
      while (l-- > 2) {
-           if (name[l] == ' ' && name[l - 1] != '~')
+           if (name[l] == ' ' && name[l - 1] != FOLDERDELIMCHAR)
               name[l] = 0;
            else
               break;
@@ -853,7 +853,7 @@
      struct tm tm_r;
      struct tm *t = localtime_r(&start, &tm_r);
      char *s;
-     if (Level > 0 && (s = strrchr(name, '~')) != NULL)
+     if (Level > 0 && (s = strrchr(name, FOLDERDELIMCHAR)) != NULL)
         s++;
      else
         s = name;
@@ -867,18 +867,18 @@
                             New,
                             Delimiter,
                             s));
-     // let's not display a trailing '~':
+     // let's not display a trailing FOLDERDELIMCHAR:
      if (!NewIndicator)
         stripspace(titleBuffer);
      s = &titleBuffer[strlen(titleBuffer) - 1];
-     if (*s == '~')
+     if (*s == FOLDERDELIMCHAR)
         *s = 0;
      }
   else if (Level < HierarchyLevels()) {
      const char *s = name;
      const char *p = s;
      while (*++s) {
-           if (*s == '~') {
+           if (*s == FOLDERDELIMCHAR) {
               if (Level--)
                  p = s + 1;
               else
@@ -911,7 +911,7 @@
   const char *s = name;
   int level = 0;
   while (*++s) {
-        if (*s == '~')
+        if (*s == FOLDERDELIMCHAR)
            level++;
         }
   return level;
@@ -919,7 +919,7 @@
 
 bool cRecording::IsEdited(void) const
 {
-  const char *s = strrchr(name, '~');
+  const char *s = strrchr(name, FOLDERDELIMCHAR);
   s = !s ? name : s + 1;
   return *s == '%';
 }
diff -ruN vdr-1.7.11/recording.h vdr-1.7.12/recording.h
--- vdr-1.7.11/recording.h	2010-01-02 13:10:07.000000000 +0100
+++ vdr-1.7.12/recording.h	2010-01-16 12:16:20.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.h 2.12 2010/01/02 12:10:07 kls Exp $
+ * $Id: recording.h 2.13 2010/01/16 11:16:20 kls Exp $
  */
 
 #ifndef __RECORDING_H
@@ -18,6 +18,8 @@
 #include "timers.h"
 #include "tools.h"
 
+#define FOLDERDELIMCHAR '~'
+
 extern bool VfatFileSystem;
 extern int InstanceId;
 
diff -ruN vdr-1.7.11/remux.c vdr-1.7.12/remux.c
--- vdr-1.7.11/remux.c	2009-12-29 16:56:33.000000000 +0100
+++ vdr-1.7.12/remux.c	2010-01-30 11:43:12.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.c 2.37 2009/12/29 15:56:33 kls Exp $
+ * $Id: remux.c 2.41 2010/01/30 10:43:12 kls Exp $
  */
 
 #include "remux.h"
@@ -144,7 +144,7 @@
 
 // --- cPatPmtGenerator ------------------------------------------------------
 
-cPatPmtGenerator::cPatPmtGenerator(cChannel *Channel)
+cPatPmtGenerator::cPatPmtGenerator(const cChannel *Channel)
 {
   numPmtPackets = 0;
   patCounter = pmtCounter = 0;
@@ -243,7 +243,7 @@
 #define P_PMT_PID 0x0084 // pseudo PMT pid
 #define MAXPID    0x2000 // the maximum possible number of pids
 
-void cPatPmtGenerator::GeneratePmtPid(cChannel *Channel)
+void cPatPmtGenerator::GeneratePmtPid(const cChannel *Channel)
 {
   bool Used[MAXPID] = { false };
 #define SETPID(p) { if ((p) >= 0 && (p) < MAXPID) Used[p] = true; }
@@ -287,7 +287,7 @@
   IncVersion(patVersion);
 }
 
-void cPatPmtGenerator::GeneratePmt(cChannel *Channel)
+void cPatPmtGenerator::GeneratePmt(const cChannel *Channel)
 {
   // generate the complete PMT section:
   uchar buf[MAX_SECTION_SIZE];
@@ -295,7 +295,7 @@
   numPmtPackets = 0;
   if (Channel) {
      int Vpid = Channel->Vpid();
-     int Ppid = 0x1FFF; // no PCR pid
+     int Ppid = Channel->Ppid();
      uchar *p = buf;
      int i = 0;
      p[i++] = 0x02; // table id
@@ -364,7 +364,7 @@
   pmtVersion = PmtVersion & 0x1F;
 }
 
-void cPatPmtGenerator::SetChannel(cChannel *Channel)
+void cPatPmtGenerator::SetChannel(const cChannel *Channel)
 {
   if (Channel) {
      GeneratePmtPid(Channel);
@@ -402,6 +402,7 @@
   patVersion = pmtVersion = -1;
   pmtPid = -1;
   vpid = vtype = 0;
+  ppid = 0;
 }
 
 void cPatPmtParser::ParsePat(const uchar *Data, int Length)
@@ -486,6 +487,7 @@
      int NumDpids = 0;
      int NumSpids = 0;
      vpid = vtype = 0;
+     ppid = 0;
      apids[0] = 0;
      dpids[0] = 0;
      spids[0] = 0;
@@ -500,6 +502,7 @@
            case 0x1B: // MPEG4
                       vpid = stream.getPid();
                       vtype = stream.getStreamType();
+                      ppid = Pmt.getPCRPid();
                       break;
            case 0x03: // STREAMTYPE_11172_AUDIO
            case 0x04: // STREAMTYPE_13818_AUDIO
@@ -842,10 +845,12 @@
                        // determine frame info:
                        if (isVideo) {
                           if (Delta % 3600 == 0)
-                             frameDuration = 3600; // PAL, 25 fps
+                             frameDuration = 3600; // PAL, 25 fps, exact timing
+                          else if (abs(Delta % 3600) == 3599 || abs(Delta % 3600) == 1)
+                             frameDuration = 3600; // PAL, 25 fps, timing with jitter
                           else if (Delta % 3003 == 0)
                              frameDuration = 3003; // NTSC, 29.97 fps
-                          else if (Delta == 1800) {
+                          else if (abs(Delta - 1800) <= 1) {
                              frameDuration = 3600; // PAL, 25 fps
                              framesPerPayloadUnit = -2;
                              }
diff -ruN vdr-1.7.11/remux.h vdr-1.7.12/remux.h
--- vdr-1.7.11/remux.h	2009-12-29 16:53:54.000000000 +0100
+++ vdr-1.7.12/remux.h	2010-01-29 17:51:26.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.h 2.23 2009/12/29 15:53:54 kls Exp $
+ * $Id: remux.h 2.24 2010/01/29 16:51:26 kls Exp $
  */
 
 #ifndef __REMUX_H
@@ -172,16 +172,16 @@
   int MakeSubtitlingDescriptor(uchar *Target, const char *Language, uchar SubtitlingType, uint16_t CompositionPageId, uint16_t AncillaryPageId);
   int MakeLanguageDescriptor(uchar *Target, const char *Language);
   int MakeCRC(uchar *Target, const uchar *Data, int Length);
-  void GeneratePmtPid(cChannel *Channel);
+  void GeneratePmtPid(const cChannel *Channel);
        ///< Generates a PMT pid that doesn't collide with any of the actual
        ///< pids of the Channel.
   void GeneratePat(void);
        ///< Generates a PAT section for later use with GetPat().
-  void GeneratePmt(cChannel *Channel);
+  void GeneratePmt(const cChannel *Channel);
        ///< Generates a PMT section for the given Channel, for later use
        ///< with GetPmt().
 public:
-  cPatPmtGenerator(cChannel *Channel = NULL);
+  cPatPmtGenerator(const cChannel *Channel = NULL);
   void SetVersions(int PatVersion, int PmtVersion);
        ///< Sets the version numbers for the generated PAT and PMT, in case
        ///< this generator is used to, e.g.,  continue a previously interrupted
@@ -191,7 +191,7 @@
        ///< higher bits will automatically be cleared.
        ///< SetVersions() needs to be called before SetChannel() in order to
        ///< have an effect from the very start.
-  void SetChannel(cChannel *Channel);
+  void SetChannel(const cChannel *Channel);
        ///< Sets the Channel for which the PAT/PMT shall be generated.
   uchar *GetPat(void);
        ///< Returns a pointer to the PAT section, which consists of exactly
@@ -213,6 +213,7 @@
   int pmtVersion;
   int pmtPid;
   int vpid;
+  int ppid;
   int vtype;
   int apids[MAXAPIDS + 1]; // list is zero-terminated
   int atypes[MAXAPIDS + 1]; // list is zero-terminated
@@ -252,6 +253,9 @@
   int Vpid(void) const { return vpid; }
        ///< Returns the video pid as defined by the current PMT, or 0 if no video
        ///< pid has been detected, yet.
+  int Ppid(void) const { return ppid; }
+       ///< Returns the PCR pid as defined by the current PMT, or 0 if no PCR
+       ///< pid has been detected, yet.
   int Vtype(void) const { return vtype; }
        ///< Returns the video stream type as defined by the current PMT, or 0 if no video
        ///< stream type has been detected, yet.
diff -ruN vdr-1.7.11/runvdr.template vdr-1.7.12/runvdr.template
--- vdr-1.7.11/runvdr.template	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.12/runvdr.template	2010-01-17 13:39:27.000000000 +0100
@@ -0,0 +1,71 @@
+#!/bin/sh
+
+# runvdr: Loads the DVB driver and runs VDR
+#
+# If VDR exits abnormally, the driver will be reloaded
+# and VDR restarted.
+#
+# In order to actually use this script you need to implement
+# the functions DriverLoaded(), LoadDriver() and UnloadDriver()
+# and maybe adjust the VDRPRG and VDRCMD to your particular
+# requirements.
+#
+# Since this script loads the DVB driver, it must be started
+# as user 'root'. Add the option "-u username" to run VDR
+# under the given user name.
+#
+# Any command line parameters will be passed on to the
+# actual 'vdr' program.
+#
+# See the main source file 'vdr.c' for copyright information and
+# how to reach the author.
+#
+# $Id: runvdr 2.1 2010/01/17 12:39:27 kls Exp $
+
+VDRPRG="./vdr"
+
+VDROPTIONS="-w 60"
+# For other options see manpage vdr.1
+
+VDRPLUGINS=""
+# You will need to select your output device plugin if you want
+# to use VDR to watch video. For instance, for a "Full Featured"
+# DVB card that would be
+# VDRPLUGINS="-P dvbsddevice"
+
+VDRCMD="$VDRPRG $VDROPTIONS $VDRPLUGINS $*"
+
+KILL="/usr/bin/killall -q -TERM"
+
+# Detect whether the DVB driver is already loaded
+# and return 0 if it *is* loaded, 1 if not:
+function DriverLoaded()
+{
+  return 1
+}
+
+# Load all DVB driver modules needed for your hardware:
+function LoadDriver()
+{
+}
+
+# Unload all DVB driver modules loaded in LoadDriver():
+function UnloadDriver()
+{
+}
+
+# Load driver if it hasn't been loaded already:
+if ! DriverLoaded; then
+   LoadDriver
+   fi
+
+while (true) do
+      eval "$VDRCMD"
+      if test $? -eq 0 -o $? -eq 2; then exit; fi
+      echo "`date` reloading DVB driver"
+      $KILL $VDRPRG
+      sleep 10
+      UnloadDriver
+      LoadDriver
+      echo "`date` restarting VDR"
+      done
diff -ruN vdr-1.7.11/svdrp.c vdr-1.7.12/svdrp.c
--- vdr-1.7.11/svdrp.c	2010-01-03 16:41:26.000000000 +0100
+++ vdr-1.7.12/svdrp.c	2010-01-17 13:23:31.000000000 +0100
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 2.7 2010/01/03 15:41:26 kls Exp $
+ * $Id: svdrp.c 2.8 2010/01/17 12:23:31 kls Exp $
  */
 
 #include "svdrp.h"
@@ -79,7 +79,7 @@
      struct sockaddr_in name;
      name.sin_family = AF_INET;
      name.sin_port = htons(port);
-     name.sin_addr.s_addr = htonl(INADDR_ANY);
+     name.sin_addr.s_addr = SVDRPhosts.LocalhostOnly() ? htonl(INADDR_LOOPBACK) : htonl(INADDR_ANY);
      if (bind(sock, (struct sockaddr *)&name, sizeof(name)) < 0) {
         LOG_ERROR;
         Close();
diff -ruN vdr-1.7.11/timers.c vdr-1.7.12/timers.c
--- vdr-1.7.11/timers.c	2009-08-09 14:43:20.000000000 +0200
+++ vdr-1.7.12/timers.c	2010-01-16 12:18:53.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: timers.c 2.3 2009/08/09 12:43:20 kls Exp $
+ * $Id: timers.c 2.4 2010/01/16 11:18:53 kls Exp $
  */
 
 #include "timers.h"
@@ -301,7 +301,7 @@
      //TODO add more plausibility checks
      result = ParseDay(daybuffer, day, weekdays);
      if (VfatFileSystem) {
-        char *p = strrchr(filebuffer, '~');
+        char *p = strrchr(filebuffer, FOLDERDELIMCHAR);
         if (p)
            p++;
         else
diff -ruN vdr-1.7.11/transfer.c vdr-1.7.12/transfer.c
--- vdr-1.7.11/transfer.c	2009-12-06 15:22:23.000000000 +0100
+++ vdr-1.7.12/transfer.c	2010-01-30 12:10:25.000000000 +0100
@@ -4,17 +4,17 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: transfer.c 2.4 2009/12/06 14:22:23 kls Exp $
+ * $Id: transfer.c 2.5 2010/01/30 11:10:25 kls Exp $
  */
 
 #include "transfer.h"
 
 // --- cTransfer -------------------------------------------------------------
 
-cTransfer::cTransfer(tChannelID ChannelID, int VPid, const int *APids, const int *DPids, const int *SPids)
-:cReceiver(ChannelID, -1, VPid, APids, Setup.UseDolbyDigital ? DPids : NULL, SPids)
+cTransfer::cTransfer(const cChannel *Channel)
+:cReceiver(Channel)
 {
-  patPmtGenerator.SetChannel(Channels.GetByChannelID(ChannelID));
+  patPmtGenerator.SetChannel(Channel);
 }
 
 cTransfer::~cTransfer()
@@ -55,8 +55,8 @@
 
 cDevice *cTransferControl::receiverDevice = NULL;
 
-cTransferControl::cTransferControl(cDevice *ReceiverDevice, tChannelID ChannelID, int VPid, const int *APids, const int *DPids, const int *SPids)
-:cControl(transfer = new cTransfer(ChannelID, VPid, APids, DPids, SPids), true)
+cTransferControl::cTransferControl(cDevice *ReceiverDevice, const cChannel *Channel)
+:cControl(transfer = new cTransfer(Channel), true)
 {
   ReceiverDevice->AttachReceiver(transfer);
   receiverDevice = ReceiverDevice;
diff -ruN vdr-1.7.11/transfer.h vdr-1.7.12/transfer.h
--- vdr-1.7.11/transfer.h	2008-05-25 14:44:49.000000000 +0200
+++ vdr-1.7.12/transfer.h	2010-01-29 17:38:09.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: transfer.h 2.1 2008/05/25 12:44:49 kls Exp $
+ * $Id: transfer.h 2.2 2010/01/29 16:38:09 kls Exp $
  */
 
 #ifndef __TRANSFER_H
@@ -21,7 +21,7 @@
   virtual void Activate(bool On);
   virtual void Receive(uchar *Data, int Length);
 public:
-  cTransfer(tChannelID ChannelID, int VPid, const int *APids, const int *DPids, const int *SPids);
+  cTransfer(const cChannel *Channel);
   virtual ~cTransfer();
   };
 
@@ -30,7 +30,7 @@
   cTransfer *transfer;
   static cDevice *receiverDevice;
 public:
-  cTransferControl(cDevice *ReceiverDevice, tChannelID ChannelID, int VPid, const int *APids, const int *DPids, const int *SPids);
+  cTransferControl(cDevice *ReceiverDevice, const cChannel *Channel);
   ~cTransferControl();
   virtual void Hide(void) {}
   static cDevice *ReceiverDevice(void) { return receiverDevice; }
diff -ruN vdr-1.7.11/vdr.c vdr-1.7.12/vdr.c
--- vdr-1.7.11/vdr.c	2010-01-02 12:52:40.000000000 +0100
+++ vdr-1.7.12/vdr.c	2010-01-31 12:14:40.000000000 +0100
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.tvdr.de
  *
- * $Id: vdr.c 2.14 2010/01/02 11:52:40 kls Exp $
+ * $Id: vdr.c 2.16 2010/01/31 11:14:40 kls Exp $
  */
 
 #include <getopt.h>
@@ -582,11 +582,12 @@
   Diseqcs.Load(AddDirectory(ConfigDirectory, "diseqc.conf"), true, Setup.DiSEqC);
   Channels.Load(AddDirectory(ConfigDirectory, "channels.conf"), false, true);
   Timers.Load(AddDirectory(ConfigDirectory, "timers.conf"));
-  Commands.Load(AddDirectory(ConfigDirectory, "commands.conf"), true);
-  RecordingCommands.Load(AddDirectory(ConfigDirectory, "reccmds.conf"), true);
+  Commands.Load(AddDirectory(ConfigDirectory, "commands.conf"));
+  RecordingCommands.Load(AddDirectory(ConfigDirectory, "reccmds.conf"));
   SVDRPhosts.Load(AddDirectory(ConfigDirectory, "svdrphosts.conf"), true);
   Keys.Load(AddDirectory(ConfigDirectory, "remote.conf"));
   KeyMacros.Load(AddDirectory(ConfigDirectory, "keymacros.conf"), true);
+  Folders.Load(AddDirectory(ConfigDirectory, "folders.conf"));
 
   if (!*cFont::GetFontFileName(Setup.FontOsd)) {
      const char *msg = "no fonts available - OSD will not show any text!";
